import AV from 'leancloud-storage'

export function createTodo (todoObj, userObj) {
  let todo = new AV.Object('Todo')
  if (!userObj || !userObj.id) {
    return
  }
  if (!todoObj || !todoObj.title) {
    return
  }
  let userAV = AV.Object.createWithoutData('User', userObj.id)
  todo.set('title', todoObj.title)
  todo.set('content', todoObj.content)
  todo.set('done', todoObj.done)
  todo.set('owner', userAV)
  todo.save().then(() => { console.log('save successfullly!') }, () => {
    console.log('save failed!')
  })
}

export function updateTodo (todoObj) {
  if (!todoObj || !todoObj.id) { return }
  let todo = AV.Object.createWithoutData('Todo', todoObj.id)
  todo.set('title', todoObj.title)
  todo.set('content', todoObj.content)
  todo.set('done', todoObj.done)
  todo.save().then(() => { console.log('update successfullly!') }, () => {
    console.log('update failed!')
  })
}

export function removeTodo (todoObj) {
  if (!todoObj || !todoObj.id) { return }
  let todo = AV.Object.createWithoutData('Todo', todoObj.id)
  todo.destroy().then(() => { console.log('delete successfullly!') }, () => {
    console.log('delete failed!')
  })
}

export function getTodosByUserObj (userObj) {
  console.log(this)
  let todoList = []
  let query = new AV.Query('Todo')
  let User = AV.Object.createWithoutData('User', userObj.id)
  query.equalTo('owner', User)
  query.find().then((todos) => {
    // transfer todo<AV.Object> to todo <in todoList>
    for (let todo of todos) {
      let { id, createdAt, attributes: { title, content, done } } = todo
      todoList.push({ id, createdAt, title, content, done, unfold: false })
    }
  }, (err) => { console.log(err) })
  return todoList
}
